【POJ 2449】 Remmarguts' Date

【题目链接】

http://poj.org/problem?id=2449

【算法】

A*(启发式搜索)

首先,求第k短路可以用优先队列BFS实现,当T第k次入队时,就求得了第k短路,但是,这种做法的复杂度太高

考虑使用A*算法,每个点的估价函数就是这个点到T的最短路,不妨将所有的边反过来求最短路,这样就得到了所有点的估价函数

这种算法的复杂度是优秀的

【代码】

#include <algorithm>
#include <bitset>
#include <cctype>
#include <cerrno>
#include <clocale>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <limits>
#include <list>
#include <map>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <utility>
#include <vector>
#include <cwchar>
#include <cwctype>
#include <stack>
#include <limits.h>
using namespace std;
#define MAXN 1010
#define MAXM 100010
const int INF = 2e9;

int i,n,m,tot,rtot,u,v,w,S,T,K;
int head[MAXN],rhead[MAXN],dist[MAXN];

struct Edge
{
        int to,w,nxt;
} e[MAXM<<1];
struct info
{
        int s,d;
        friend bool operator < (info a,info b)
        {
                return a.d + dist[a.s] > b.d + dist[b.s];
        }
} ;

inline void add(int u,int v,int w)
{
        tot++;
        e[tot] = (Edge){v,w,head[u]};
        head[u] = tot;
        tot++;
        e[tot] = (Edge){u,w,rhead[v]};
        rhead[v] = tot;
}
inline void dijkstra(int s)
{
        int i,v,w;
        priority_queue< pair<int,int> > q;
        pair<int,int> cur;
        static bool visited[MAXN];
        while (!q.empty()) q.pop();
        for (i = 1; i <= n; i++)
        {
                dist[i] = INF;
                visited[i] = false;
        }
        dist[s] = 0;
        q.push(make_pair(0,s));
        while (!q.empty())
        {
                cur = q.top();
                q.pop();
                if (visited[cur.second]) continue;
                visited[cur.second] = true;
                for (i = rhead[cur.second]; i; i = e[i].nxt)
                {
                        v = e[i].to;
                        w = e[i].w;
                        if (dist[cur.second] + w < dist[v])
                        {
                                dist[v] = dist[cur.second] + w;
                                q.push(make_pair(-dist[v],v));
                        }
                }
        }
}
inline int Astar(int s,int t,int k)
{
        int i,cnt = 0,v,w;
        priority_queue< info > q;
        info cur;
        while (!q.empty()) q.pop();
        q.push((info){s,0});
        while (!q.empty())
        {
                cur = q.top();
                q.pop();
                if (cur.s == t)
                {
                        cnt++;
                        if (cnt == k) return cur.d;
                }
                for (i = head[cur.s]; i; i = e[i].nxt)
                {
                        v = e[i].to;
                        w = e[i].w;
                        q.push((info){v,cur.d+w});
                }
        }
        return -1;
}

int main()
{

        while (scanf("%d%d",&n,&m) != EOF)
        {
                tot = rtot = 0;
                for (i = 1; i <= n; i++) head[i] = rhead[i] = 0;
                for (i = 1; i <= m; i++)
                {
                        scanf("%d%d%d",&u,&v,&w);
                        add(u,v,w);
                }
                scanf("%d%d%d",&S,&T,&K);
                if (S == T) K++;
                dijkstra(T);
                printf("%d\n",Astar(S,T,K));
        }

        return 0;

}

【POJ 2449】 Remmarguts' Date

原文地址:https://www.cnblogs.com/evenbao/p/9270595.html

时间: 2025-01-09 01:31:03

【POJ 2449】 Remmarguts' Date的相关文章

【POJ】【2449】Remmarguts&#39; Date

K短路/A* 经(luo)典(ti) K短路题目= = K短路学习:http://www.cnblogs.com/Hilda/p/3226692.html 流程: 先把所有边逆向,做一遍dijkstra,得到估价函数h(x)(x到T的最短路距离) f(x)=g(x)+h(x) 按f(x)维护一个堆……T第k次出堆时的g(T)即为ans 另外,需要特判:如果S==T,k++ 1 Source Code 2 Problem: 2449 User: sdfzyhy 3 Memory: 11260K T

【poj2449】 Remmarguts&#39; Date

http://poj.org/problem?id=2449 (题目链接) 题意 求有向图K短路. Solution A*.g(x)为当前节点到起点的步数,h(x)为当前节点到终点的最短距离(也就是估价函数). 细节 dijkstra求终点到各点最短路时要把边反向.原来起点和终点可以是同一个点,坑死了... 代码 // poj2499 #include<algorithm> #include<iostream> #include<cstdlib> #include<

【POJ 1408】 Fishnet (叉积求面积)

[POJ 1408] Fishnet (叉积求面积) 一个1*1㎡的池塘 有2*n条线代表渔网 问这些网中围出来的最大面积 一个有效面积是相邻两行和相邻两列中间夹的四边形 Input为n 后面跟着四行 每行n个浮点数 每一行分别代表a,b,c,d 如图 并且保证a(i) > a(i-1) b(i) > b(i-1) c(i) > c(i-1) d(i) > d(i-1) n(n <= 30)*2+4(四个岸)条边 枚举点数就行 相邻的四个四个点枚举 找出围出的最大面积 找点用

【POJ 2513】Colored Sticks

[POJ 2513]Colored Sticks 并查集+字典树+欧拉通路 第一次做这么混的题..太混了-- 不过题不算难 字典树用来查字符串对应图中的点 每个单词做一个点(包括重复单词 题意就是每个边走且直走一次(欧拉通路 欧拉图的判定: 没有或者只有两个奇数度的点的图叫做欧拉图 有这些就可以解答此题了 另外需要注意题目范围是25W个木棍 所以最多可能有50W个点 卡了好多个RE 代码如下: #include <iostream> #include <cstdlib> #incl

2292: 【POJ Challenge 】永远挑战

2292: [POJ Challenge ]永远挑战 Time Limit: 10 Sec  Memory Limit: 128 MBSubmit: 553  Solved: 230[Submit][Status][Discuss] Description lqp18_31和1tthinking经常出题来虐ftiasch.有一天, lqp18_31搞了一个有向图,每条边的长度都是1. 他想让ftiasch求出点1到点 N 的最短路."水题啊.", ftiasch这么说道. 所以1tth

【POJ 1201】 Intervals(差分约束系统)

[POJ 1201] Intervals(差分约束系统) 11 1716的升级版 把原本固定的边权改为不固定. Intervals Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 23817   Accepted: 9023 Description You are given n closed, integer intervals [ai, bi] and n integers c1, ..., cn. Write a p

【POJ 1228】Grandpa&#39;s Estate 凸包

找到凸包后暴力枚举边进行$check$,注意凸包是一条线(或者说两条线)的情况要输出$NO$ #include<cmath> #include<cstdio> #include<cstring> #include<algorithm> #define N 1003 #define read(x) x = getint() using namespace std; inline int getint() { int k = 0, fh = 1; char c

【POJ 2750】 Potted Flower(线段树套dp)

[POJ 2750] Potted Flower(线段树套dp) Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 4566   Accepted: 1739 Description The little cat takes over the management of a new park. There is a large circular statue in the center of the park, surrou

【POJ 2480】Longge&#39;s problem(欧拉函数)

题意 求$ \sum_{i=1}^n gcd(i,n) $ 给定 $n(1\le n\le 2^{32}) $. 链接 分析 用欧拉函数$φ(x)$求1到x-1有几个和x互质的数. gcd(i,n)必定是n的一个约数.若p是n的约数,那么gcd(i,n)==p的有$φ(n/p)$个数,因为要使gcd(i,n)==p,i/p和n/p必须是互质的.那么就是求i/p和n/p互质的i在[1,n]里有几个,就等价于,1/p,2/p,...,n/p里面有几个和n/p互质,即φ(n/p). 求和的话,约数为p